
# This is program is written by Guogen Shan and Weizhen Wang for paper
# "Exact Confidence Intervals for the Relative Risk and the Odds Ratio" (2015), Biometrics 71, 985-995.
# All rights reserved.

# The CI for the odds ratio based on two independent binomials is computed.

timea<-Sys.time()

n1=23;n2=32
x=0
y=(n2+1)



confidence.level=0.975
alternative="Lower"
precision=0.000001
grid.one=60
grid.two=40
calnum=0

delta<-10^(-10)

n<-n1
m<-n2
pround=0
while(1/precision>=10^pround)
{pround=pround+1}
#pround<-pround-1

datavectorL<-x*(m+2)+y
datavectorU<-(n-x)*(m+2)+m-y
output<-c()
output[1]<-round(x/n-y/m,digits=6)

alpha<-1-confidence.level
f<-array(,dim=c((n+1)*(m+1),6))
S<-array(,dim=c((n+1)*(m+1),2))
N<-array(,dim=c((n+1)*(m+1),3))
NC<-array(,dim=c((n+1)*(m+1),3))
Ls<-array(,dim=c((n+1)*(m+1),6))

num=0
for(i in 0:n)
for(j in 0:m)
{
num=num+1
f[num,1:2]=c(i,j)
}

p1hat<-f[,1]/n+delta
p0hat<-f[,2]/m+delta
denom<-p1hat*(1-p1hat)/n+p0hat*(1-p0hat)/m+delta
f[,3]=(p1hat/p0hat)

f<-f[order(-f[,3]),]

allvector<-f[,1]*(m+2)+f[,2]
allvector<-round(allvector)

allvectormove<-(f[,1]+1)*(m+3)+(f[,2]+1)
allvectormove<-round(allvectormove)

############### for the first table ############################

I1<-f[1,1]+delta
I2<-f[1,2]+delta

prob<-function(delv)
{
delvalue<-delv
upperp2<-2
u0<-seq(delta,upperp2-delta,length=grid.one)
p0<-u0/2-(1+delvalue-sqrt((delvalue-1)^2*(u0-1)^2+4*delvalue))/(2*(delvalue-1))
part1<-lchoose(n,I1) + I1%*%t(log(p0*delvalue/(1-p0+p0*delvalue))) + (n-I1)%*%t(log(1-p0*delvalue/(1-p0+p0*delvalue)))
part2<-lchoose(m,I2) + I2%*%t(log(p0)) + (m-I2)%*%t(log(1-p0))
sum<-part1+part2
expsum<-exp(sum)
sumofprob<-colSums(expsum)
mansum<-max(sumofprob)
return(mansum)
}


imax=1000-100*delta
imin=delta
while(abs(imax-imin)>=0.00001)
{
mid<-(imax+imin)/2
probmid<-prob(mid)
if(probmid>=alpha)
{imax<-mid}else{imin<-mid}
}
f[1,4]=round(imin,digits=pround)
Ls[1,]<-f[1,]

partvector<-round(Ls[1,1]*(m+2)+Ls[1,2])
allvector<-setdiff(allvector,partvector)



################### from the second table  ################################

morepoint=1
kk=1
kk1=1
dimoftable<-dim(Ls)[1]

if(x==n && y==0 && alternative=="Lower"){output[2]=Ls[1,4];output[3]=1;kk<-dimoftable}
if(x==0 && y==m && alternative=="Lower"){output[2]=-1;output[3]=1;kk<-dimoftable}
if(x==n && y==0 && alternative=="Upper"){output[2]=-1;output[3]=1;kk<-dimoftable}
if(x==0 && y==m && alternative=="Upper"){output[2]=-1;output[3]=-Ls[1,4];kk<-dimoftable}



while(kk<=(dimoftable-2))
{
C<-round(Ls[(kk-morepoint+1):kk,1:2])
S[(kk-morepoint+1):kk,]<-C
DD<-S[1:kk,]
if(kk==1){DD[1]<-DD[1]-1}else{
DD[,1]<-DD[,1]-1}
A<-DD
DD<-S[1:kk,]
if(kk==1){DD[2]<-DD[2]+1}else{
DD[,2]<-DD[,2]+1}
B<-DD

################### generate N ##### 
N<-rbind(A,B)
N<-unique(N)

Nvector<-c()
Nvector<-(N[,1]+1)*(m+3)+N[,2]+1
Nvector<-Nvector[is.element(Nvector,allvectormove)]

SKvector<-(S[1:kk,1]+1)*(m+3)+S[1:kk,2]+1
Nvectortemp<-Nvector[!is.element(Nvector,SKvector)]
Ntemp<-array(,dim=c(length(Nvectortemp),2))
Ntemp[,2]<-Nvectortemp%%(m+3)
Ntemp[,1]<-(Nvectortemp-Ntemp[,2])/(m+3)-1
Ntemp[,2]<-Ntemp[,2]-1
N<-Ntemp


#################### generate NC ####
Nvector<-(N[,1]+1)*(m+3)+N[,2]+1
Nvector1<-(N[,1]+2)*(m+3)+N[,2]+1
Nvector2<-(N[,1]+1)*(m+3)+N[,2]+0
drop<-is.element(Nvector1,Nvector)*1+is.element(Nvector2,Nvector)*1
M<-cbind(N,drop)
MM<-M[which(M[,3]<0.5),]
NC<-MM


if(length(NC)<=3){lengthNC=1;NMN=array(c(100,100,100,100,100,100),dim=c(2,3));NMN[1,]<-NC;NC<-NMN}else{lengthNC=length(na.omit(NC[,1]))}
for(i in 1:lengthNC)
{
imax=100-100*delta
imin=delta

Ls[kk+1,1:2]<-NC[i,1:2]
I1<-Ls[1:(kk+1),1]+delta
I2<-Ls[1:(kk+1),2]+delta


if(kk>(dimoftable-2)/2)
{
partvector<-round(NC[i,1]*(m+2)+NC[i,2])
leftvector<-setdiff(allvector,partvector)
I2<-round(leftvector%%(m+2))
I1<-round((leftvector-leftvector%%(m+2))/(m+2))
}




prob2step<-function(delv)
{
delvalue<-delv
upperp2<-2
u0<-seq(delta,upperp2-delta,length=grid.one)
p0<-u0/2-(1+delvalue-sqrt((delvalue-1)^2*(u0-1)^2+4*delvalue))/(2*(delvalue-1))
part1<-lchoose(n,I1) + I1%*%t(log(p0*delvalue/(1-p0+p0*delvalue))) + (n-I1)%*%t(log(1-p0*delvalue/(1-p0+p0*delvalue)))
part2<-lchoose(m,I2) + I2%*%t(log(p0)) + (m-I2)%*%t(log(1-p0))
sum<-part1+part2
expsum<-exp(sum)
sumofprob<-colSums(expsum)
mansum<-max(sumofprob)
stepv<-(u0[grid.one]-u0[1])/grid.one
maxloc<-which(sumofprob==mansum)
lowerb<-max(u0[1],u0[maxloc]-stepv)+delta
upperb<-min(u0[grid.one],u0[maxloc]+stepv)-delta
u0<-seq(lowerb,upperb,length=grid.two)
p0<-u0/2-(1+delvalue-sqrt((delvalue-1)^2*(u0-1)^2+4*delvalue))/(2*(delvalue-1))
part1<-lchoose(n,I1) + I1%*%t(log(p0*delvalue/(1-p0+p0*delvalue))) + (n-I1)%*%t(log(1-p0*delvalue/(1-p0+p0*delvalue)))
part2<-lchoose(m,I2) + I2%*%t(log(p0)) + (m-I2)%*%t(log(1-p0))
sum<-part1+part2
expsum<-exp(sum)
sumofprob<-colSums(expsum)
mansum<-max(sumofprob)
return(mansum)
}



prob2steplmin<-function(delv)
{
delvalue<-delv
upperp2<-2
u0<-seq(delta,upperp2-delta,length=grid.one)
p0<-u0/2-(1+delvalue-sqrt((delvalue-1)^2*(u0-1)^2+4*delvalue))/(2*(delvalue-1))
part1<-lchoose(n,I1) + I1%*%t(log(p0*delvalue/(1-p0+p0*delvalue))) + (n-I1)%*%t(log(1-p0*delvalue/(1-p0+p0*delvalue)))
part2<-lchoose(m,I2) + I2%*%t(log(p0)) + (m-I2)%*%t(log(1-p0))
sum<-part1+part2
expsum<-exp(sum)
sumofprob<-colSums(expsum)
mansum<-min(sumofprob)
stepv<-(u0[grid.one]-u0[1])/grid.one
maxloc<-which(sumofprob==mansum)
lowerb<-max(u0[1],u0[maxloc]-stepv)+delta
upperb<-min(u0[grid.one],u0[maxloc]+stepv)-delta
u0<-seq(lowerb,upperb,length=grid.two)
p0<-u0/2-(1+delvalue-sqrt((delvalue-1)^2*(u0-1)^2+4*delvalue))/(2*(delvalue-1))
part1<-lchoose(n,I1) + I1%*%t(log(p0*delvalue/(1-p0+p0*delvalue))) + (n-I1)%*%t(log(1-p0*delvalue/(1-p0+p0*delvalue)))
part2<-lchoose(m,I2) + I2%*%t(log(p0)) + (m-I2)%*%t(log(1-p0))
sum<-part1+part2
expsum<-exp(sum)
sumofprob<-colSums(expsum)
mansum<-min(sumofprob)
return(mansum)
}


imax=Ls[kk,4]
imin=delta
if(i==1){NCmax<-0.00001}
zeroor<-NC[i,1]^2
zeroor2<-NC[i,2]^2
checkva<-n2^2-0.01


if(zeroor>0.001 && zeroor2<checkva)
{
if(kk<=(dimoftable-2)/2){
if(i==1){
while(abs(imax-imin)>=precision)
{
mid<-(imax+imin)/2
probmid<-prob2step(mid)
if(probmid>=alpha)
{imax<-mid}else{imin<-mid}
}
NC[i,3]<-round(imin,digits=pround)                               
         } ## i==1
if(i>1){
sectable=prob2step(NCmax)
if(sectable<(1-confidence.level+0.00000001)){
imin<-NCmax*0.9
print(c(i,lengthNC,kk,dimoftable))
calnum=calnum+1
while(abs(imax-imin)>=precision)
{
mid<-(imax+imin)/2
probmid<-prob2step(mid)
if(probmid>=alpha)
{imax<-mid}else{imin<-mid}
}
NC[i,3]<-round(imin,digits=pround)                      
         }else{ 
imin=NCmax-0.2
NC[i,3]<-round(imin,digits=pround)
               }
         }## i>1
NCmax<-max(NCmax,imin,0.00001)
         }else{
if(i==1){
while(abs(imax-imin)>=precision)
{
mid<-(imax+imin)/2
probmid<-prob2steplmin(mid)
if(probmid>=(1-alpha))
{imin<-mid}else{imax<-mid}
}
NC[i,3]<-round(imin,digits=pround) 
NCmax<-max(NCmax,imin,0.00001)                              
         } ## i==1
if(i>1){
sectable=prob2steplmin(NCmax)
if(sectable>(1-confidence.level-0.000000001)){
imin<-NCmax*0.9
print(c(i,lengthNC,kk,dimoftable))
calnum=calnum+1
while(abs(imax-imin)>=precision)
{
mid<-(imax+imin)/2
probmid<-prob2steplmin(mid)
if(probmid>=(1-alpha))
{imin<-mid}else{imax<-mid}
}
NC[i,3]<-round(imin,digits=pround)                      
         }else{ 
imin=NCmax-0.2
NC[i,3]<-round(imin,digits=pround)
               }
         }## i>1
NCmax<-max(NCmax,imin,0.00001)
                } # end of else
}else{NC[i,3]<-0}                 #end of zero check
}
##  end of i loop


morepointLsest<-function(morekk)
{
imax=1-100*delta
imin=delta

I1<-Ls[1:morekk,1]+delta
I2<-Ls[1:morekk,2]+delta

prob2step<-function(delv)
{
delvalue<-delv
upperp2<-2
u0<-seq(delta,upperp2-delta,length=grid.one)
p0<-u0/2-(1+delvalue-sqrt((delvalue-1)^2*(u0-1)^2+4*delvalue))/(2*(delvalue-1))
part1<-lchoose(n,I1) + I1%*%t(log(p0*delvalue/(1-p0+p0*delvalue))) + (n-I1)%*%t(log(1-p0*delvalue/(1-p0+p0*delvalue)))
part2<-lchoose(m,I2) + I2%*%t(log(p0)) + (m-I2)%*%t(log(1-p0))
sum<-part1+part2
expsum<-exp(sum)
sumofprob<-colSums(expsum)
mansum<-max(sumofprob)
stepv<-(u0[grid.one]-u0[1])/grid.one
maxloc<-which(sumofprob==mansum)
lowerb<-max(u0[1],u0[maxloc]-stepv)+delta
upperb<-min(u0[grid.one],u0[maxloc]+stepv)-delta
u0<-seq(lowerb,upperb,length=grid.two)
p0<-u0/2-(1+delvalue-sqrt((delvalue-1)^2*(u0-1)^2+4*delvalue))/(2*(delvalue-1))
part1<-lchoose(n,I1) + I1%*%t(log(p0*delvalue/(1-p0+p0*delvalue))) + (n-I1)%*%t(log(1-p0*delvalue/(1-p0+p0*delvalue)))
part2<-lchoose(m,I2) + I2%*%t(log(p0)) + (m-I2)%*%t(log(1-p0))
sum<-part1+part2
expsum<-exp(sum)
sumofprob<-colSums(expsum)
mansum<-max(sumofprob)
return(mansum)
}

imax=Ls[kk,4]
imin=delta
if(i==1){NCmax<-0.00001}

while(abs(imax-imin)>=precision)
{
mid<-(imax+imin)/2
probmid<-prob2step(mid)
if(probmid>=alpha)
{imax<-mid}else{imin<-mid}
}
NCres<-round(imin,digits=pround)
return(NCres)
	}## end of function morepointLsest

if(i>=2)
{NCnomiss<-NC[1:dim(na.omit(NC))[1],]
NCnomiss<-NCnomiss[order(-NCnomiss[,3]),]
morepoint<-sum(NCnomiss[,3]>=NCnomiss[1,3]-0.0001)
if(morepoint>=2){
Ls[(kk+1):(kk+morepoint),1:2]<-NCnomiss[1:morepoint,1:2]
if(NCnomiss[1,3]>0.000001)
{Ls[(kk+1):(kk+morepoint),4]<-morepointLsest(kk+morepoint) ## the same CI for the table in the same group
}else
{Ls[(kk+1):(kk+morepoint),4]<-0}

for(iq in 1:morepoint)
{partvector<-round(Ls[kk+iq,1]*(m+2)+Ls[kk+iq,2])
allvector<-setdiff(allvector,partvector)}
kk=kk+morepoint
             }else{Ls[kk+1,1:2]<-NCnomiss[1,1:2];Ls[kk+1,4]<-NCnomiss[1,3]
                   partvector<-round(Ls[kk+1,1]*(m+2)+Ls[kk+1,2])
                   allvector<-setdiff(allvector,partvector);kk=kk+1
                   }
}else{NCnomiss<-NC
Ls[kk+1,1:2]<-NCnomiss[1,1:2]
Ls[kk+1,4]<-NCnomiss[1,3]
partvector<-round(Ls[kk+1,1]*(m+2)+Ls[kk+1,2])
allvector<-setdiff(allvector,partvector)
kk=kk+1
}

kk1=kk
}

Ls[kk+1,c(1,2,4)]=c(0,m,0)

p1hat<-Ls[,1]/n+delta
p0hat<-Ls[,2]/m+delta
Ls[,3]=(p1hat/(1-p1hat+delta)/p0hat*(1-p0hat))

Lsd<-data.frame(Ls)
Ls=Ls[,1:4]

Lsd<-data.frame(Ls)
Lsd
subset(Lsd,X1==21 & X2==19)

timeb<-Sys.time()
timeb-timea




