
# This is program is written by Guogen Shan and Weizhen Wang for paper
# "Exact Confidence Intervals for the Relative Risk and the Odds Ratio" (2015), Biometrics 71, 985-995.
# All rights reserved.

# The CI for the paired odds ratio based on a 2X2 multinomial (n, p11,p12,p21) is computed.
# It may take hours

timea<-Sys.time()

##
#n12=5
#t=10
#n21=5
#n<-n12+t+n21
calnum=0

#n<-32

### data 2 8 2 5 R paper 16 9 3 4
#datavector<-round(1*(n+2)^2+1*(n+2)+1)
#datavector<-round(16*(n+2)^2+9*(n+2)+3)

numindex1=0
numindex2=0

n<-21

### data 1 7 1 12
datavector<-round(1*(n+2)^2+7*(n+2)+1)
datavector12<-round(1*(n+2)^2+1*(n+2)+7)

n<-21

confidence.level=0.95
alternative="Lower"
precision=0.00001
grid.one=150
grid.two=30

delta<-10^(-10)

pround=0
while(1/precision>=10^pround)
{pround=pround+1}
pround<-min(5,pround)

alpha=1-confidence.level

f<-array(,dim=c(choose((n+3),3),8))
S<-array(,dim=c(choose((n+3),3),3))
N<-array(,dim=c(choose((n+3),3),4))
NC<-array(,dim=c(choose((n+3),3),4))
NCtemp<-array(,dim=c(choose((n+3),3),5))
Ls<-array(,dim=c(choose((n+3),3),8))

#f1=n11 f2=n12 f3=n21 n22=n-f1-f2-f3 

num=0
for(i in 0:n)
for(j in 0:(n-i))
for(k in 0:(n-i-j))
{
num=num+1
f[num,1:3]=c(i,j,k)
}
num

p1hat<-(f[,1]+f[,2]+delta)/(n+100*delta)
p0hat<-(f[,1]+f[,3]+delta)/(n+100*delta)
f[,7]=(p1hat*(1-p0hat)/p0hat/(1-p1hat))


f<-f[order(-f[,7]),]

allvector<-f[,1]*(n+2)^2+f[,2]*(n+2)+f[,3]
allvector<-round(allvector)

allvectormove<-(f[,1]+1)*(n+3)^2+(f[,2]+1)*(n+3)+(f[,3]+1)
allvectormove<-round(allvectormove)

############### for the first table ############################


probgrid<-function(midv)
{
delta<-10^{-26}
theta11_g<-seq(delta,min(1-delta,1/midv-delta),length=grid.one)
theta21_g<-seq(delta,min(1-delta,1/(midv+1)-delta),length=grid.one)
theta11<-rep(theta11_g,times=grid.one)
theta21<-rep(theta21_g,each=grid.one)
thetarr<-midv
#theta12<-theta11*(1-theta11-theta21)/(theta11+thetarr*theta21+delta)
theta12<-(thetarr*(theta11+theta21)*(1-theta11)-theta11*(1-theta11-theta21))/(thetarr*(theta11+theta21)+(1-theta11-theta21))
theta22<-1-theta11-theta12-theta21
thetaallone<-cbind(theta11,theta21,theta12,theta22)
thetaall<-thetaallone[which(thetaallone[,3]>delta),]
thetaall<-thetaall[which(thetaall[,3]<(1+delta)),]
thetaall<-thetaall[which(thetaall[,4]>delta),]
thetaall<-thetaall[which(thetaall[,4]<(1+delta)),]
theta11<-thetaall[,1]
theta21<-thetaall[,2]
theta12<-thetaall[,3]
theta22<-thetaall[,4]

part2<-I1%*%t(log(theta11)) +(I2)%*%t(log(theta12)) + (I3)%*%t(log(theta21)) + (I4)%*%t(log(theta22))
sum<-part1+part2
expsum<-exp(sum)
sumofprob<-colSums(expsum)
mansum<-max(sumofprob)


maxloc<-which(sumofprob==mansum)
stepv<-(max(theta11_g)-min(theta11_g))/grid.one
theta11_g<-seq(max(delta,(theta11[maxloc]-stepv+delta)),min(1-delta,1/midv-delta,(theta11[maxloc]+stepv-delta)),length=grid.two)
theta21_g<-seq(max(delta,(theta21[maxloc]-stepv+delta)),min(1-delta,1/(midv+1)-delta,(theta21[maxloc]+stepv-delta)),length=grid.two)
thetarr<-midv
theta12<-(thetarr*(theta11+theta21)*(1-theta11)-theta11*(1-theta11-theta21))/(thetarr*(theta11+theta21)+(1-theta11-theta21))
theta22<-1-theta11-theta12-theta21
thetaallone<-cbind(theta11,theta21,theta12,theta22)
thetaall<-thetaallone[which(thetaallone[,3]>delta),]
thetaall<-thetaall[which(thetaall[,3]<(1+delta)),]
thetaall<-thetaall[which(thetaall[,4]>delta),]
thetaall<-thetaall[which(thetaall[,4]<(1+delta)),]
theta11<-thetaall[,1]
theta21<-thetaall[,2]
theta12<-thetaall[,3]
theta22<-thetaall[,4]

part2<-I1%*%t(log(theta11)) +(I2)%*%t(log(theta12)) + (I3)%*%t(log(theta21)) + (I4)%*%t(log(theta22))
sum<-part1+part2
expsum<-exp(sum)
sumofprob<-colSums(expsum)
mansum<-max(sumofprob)

return(mansum)
}

probgrid_line<-function(midv)
{
delta<-10^{-26}
theta11<-seq(delta,min(1-delta,1/midv-delta),length=grid.one)
theta21<-1/(midv+1)-midv/(midv+1)*theta11
thetarr<-midv
theta12<-(thetarr*(theta11+theta21)*(1-theta11)-theta11*(1-theta11-theta21))/(thetarr*(theta11+theta21)+(1-theta11-theta21))
theta22<-1-theta11-theta12-theta21
theta22[which(abs(theta22)<10^(-12))]<-delta
theta11[which(abs(theta11)<10^(-12))]<-delta
theta12[which(abs(theta12)<10^(-12))]<-delta
theta21[which(abs(theta21)<10^(-12))]<-delta

part2<-I1%*%t(log(theta11)) +(I2)%*%t(log(theta12)) + (I3)%*%t(log(theta21)) + (I4)%*%t(log(theta22))
sum<-part1+part2
expsum<-exp(sum)
sumofprob<-colSums(expsum)
mansum<-max(sumofprob)
return(mansum)
}


probgrid_point<-function(midvv)
{
delta<-10^{-26}
theta11<-midvv[2]
thetarr<-midvv[1]
theta21<-1/(thetarr+1)-thetarr/(thetarr+1)*theta11
theta12<-(thetarr*(theta11+theta21)*(1-theta11)-theta11*(1-theta11-theta21))/(thetarr*(theta11+theta21)+(1-theta11-theta21))
theta22<-1-theta11-theta12-theta21
theta22[which(abs(theta22)<10^(-12))]<-delta
theta11[which(abs(theta11)<10^(-12))]<-delta
theta12[which(abs(theta12)<10^(-12))]<-delta
theta21[which(abs(theta21)<10^(-12))]<-delta

part2<-I1*(log(theta11)) +(I2)*(log(theta12)) + (I3)*(log(theta21)) + (I4)*(log(theta22))
sum<-part1+part2
expsum<-exp(sum)
mansum<-sum(expsum)
return(mansum)
}


probgrid_pointa<-function(midvva)
{
delta<-10^{-26}
theta11<-midvva[1]
theta12<-midvva[2]
theta21<-midvva[3]
theta22<-1-theta11-theta12-theta21

part2<-I1*(log(theta11)) +(I2)*(log(theta12)) + (I3)*(log(theta21)) + (I4)*(log(theta22))
sum<-part1+part2
expsum<-exp(sum)
mansum<-sum(expsum)
return(mansum)
}


I1<-f[1,1]
I2<-f[1,2]
I3<-f[1,3]
I4<-n-I1-I2-I3
part1<-lfactorial(n)-lfactorial(I1)-lfactorial(I2)-lfactorial(I3)-lfactorial(I4)

imax=100-100*delta
imin=0+delta
while(abs(imax-imin)>=0.00001)
{
grid.one=200
mid<-(imax+imin)/2
probmid<-probgrid(mid)
if(probmid>=alpha)
{imax<-mid}else{imin<-mid}
}
f[1,4]=round(imin,digits=pround)
Ls[1,]<-f[1,]

partvector<-round(Ls[1,1]*(n+2)^2+Ls[1,2]*(n+2)+Ls[1,3])
allector<-setdiff(allvector,partvector)
morepoint=1
kk=1
kk1=1



# after find (n,0,0), no need to use that loop
stopp=0

################### from the second table  ################################


probgridmax<-function(midv)
{
delta<-10^{-26}
theta11_g<-seq(delta,min(1-delta,1/midv-delta),length=grid.one)
theta21_g<-seq(delta,min(1-delta,1/(midv+1)-delta),length=grid.one)
theta11<-rep(theta11_g,times=grid.one)
theta21<-rep(theta21_g,each=grid.one)
thetarr<-midv
theta12<-(thetarr*(theta11+theta21)*(1-theta11)-theta11*(1-theta11-theta21))/(thetarr*(theta11+theta21)+(1-theta11-theta21))
theta22<-1-theta11-theta12-theta21
thetaallone<-cbind(theta11,theta21,theta12,theta22)
thetaall<-thetaallone[which(thetaallone[,3]>delta),]
thetaall<-thetaall[which(thetaall[,3]<(1+delta)),]
thetaall<-thetaall[which(thetaall[,4]>delta),]
thetaall<-thetaall[which(thetaall[,4]<(1+delta)),]
theta11<-thetaall[,1]
theta21<-thetaall[,2]
theta12<-thetaall[,3]
theta22<-thetaall[,4]

part2<-I1%*%t(log(theta11)) +(I2)%*%t(log(theta12)) + (I3)%*%t(log(theta21)) + (I4)%*%t(log(theta22))
sum<-part1+part2
expsum<-exp(sum)
sumofprob<-colSums(expsum)
mansum<-max(sumofprob)

maxloc<-which(sumofprob==mansum)
stepv<-(max(theta11_g)-min(theta11_g))/grid.one
theta11_g<-seq(max(delta,(theta11[maxloc]-stepv+delta)),min(1-delta,1/midv-delta,(theta11[maxloc]+stepv-delta)),length=grid.two)
theta21_g<-seq(max(delta,(theta21[maxloc]-stepv+delta)),min(1-delta,1/(midv+1)-delta,(theta21[maxloc]+stepv-delta)),length=grid.two)
thetarr<-midv
theta12<-(thetarr*(theta11+theta21)*(1-theta11)-theta11*(1-theta11-theta21))/(thetarr*(theta11+theta21)+(1-theta11-theta21))
theta22<-1-theta11-theta12-theta21
thetaallone<-cbind(theta11,theta21,theta12,theta22)
thetaall<-thetaallone[which(thetaallone[,3]>delta),]
thetaall<-thetaall[which(thetaall[,3]<(1+delta)),]
thetaall<-thetaall[which(thetaall[,4]>delta),]
thetaall<-thetaall[which(thetaall[,4]<(1+delta)),]
theta11<-thetaall[,1]
theta21<-thetaall[,2]
theta12<-thetaall[,3]
theta22<-thetaall[,4]

part2<-I1%*%t(log(theta11)) +(I2)%*%t(log(theta12)) + (I3)%*%t(log(theta21)) + (I4)%*%t(log(theta22))
sum<-part1+part2
expsum<-exp(sum)
sumofprob<-colSums(expsum)
mansum<-max(sumofprob)

return(mansum)
}

probgridmax_onlyonestage<-function(midv)
{
delta<-10^{-26}
theta11_g<-seq(delta,min(1-delta,1/midv-delta),length=grid.one)
theta21_g<-seq(delta,min(1-delta,1/(midv+1)-delta),length=grid.one)
theta11<-rep(theta11_g,times=grid.one)
theta21<-rep(theta21_g,each=grid.one)
thetarr<-midv
theta12<-(thetarr*(theta11+theta21)*(1-theta11)-theta11*(1-theta11-theta21))/(thetarr*(theta11+theta21)+(1-theta11-theta21))
theta22<-1-theta11-theta12-theta21
thetaallone<-cbind(theta11,theta21,theta12,theta22)
thetaall<-thetaallone[which(thetaallone[,3]>delta),]
thetaall<-thetaall[which(thetaall[,3]<(1+delta)),]
thetaall<-thetaall[which(thetaall[,4]>delta),]
thetaall<-thetaall[which(thetaall[,4]<(1+delta)),]
theta11<-thetaall[,1]
theta21<-thetaall[,2]
theta12<-thetaall[,3]
theta22<-thetaall[,4]

part2<-I1%*%t(log(theta11)) +(I2)%*%t(log(theta12)) + (I3)%*%t(log(theta21)) + (I4)%*%t(log(theta22))
sum<-part1+part2
expsum<-exp(sum)
sumofprob<-colSums(expsum)
mansum<-max(sumofprob)

return(mansum)
}




probgridmax_nlm<-function(midv)
{
upper11<-min(1-delta,1/midv-delta)
upper21<-min(1-delta,1/(midv+1)-delta)
delta<-10^{-26}
theta11_g<-seq(delta,upper11,length=grid.one)
theta21_g<-seq(delta,upper21,length=grid.one)
theta11<-rep(theta11_g,times=grid.one)
theta21<-rep(theta21_g,each=grid.one)
thetarr<-midv
#theta12<-theta11*(1-theta11-theta21)/(theta11+thetarr*theta21+delta)
theta12<-(thetarr*(theta11+theta21)*(1-theta11)-theta11*(1-theta11-theta21))/(thetarr*(theta11+theta21)+(1-theta11-theta21))
theta22<-1-theta11-theta12-theta21
thetaallone<-cbind(theta11,theta21,theta12,theta22)
thetaall<-thetaallone[which(thetaallone[,3]>delta),]
thetaall<-thetaall[which(thetaall[,3]<(1+delta)),]
thetaall<-thetaall[which(thetaall[,4]>delta),]
thetaall<-thetaall[which(thetaall[,4]<(1+delta)),]
theta11<-thetaall[,1]
theta21<-thetaall[,2]
theta12<-thetaall[,3]
theta22<-thetaall[,4]

part2<-I1%*%t(log(theta11)) +(I2)%*%t(log(theta12)) + (I3)%*%t(log(theta21)) + (I4)%*%t(log(theta22))
sum<-part1+part2
expsum<-exp(sum)
sumofprob<-colSums(expsum)
mansum<-max(sumofprob)

llike<-function(pnull)
{
theta11<-pnull[1]
theta21<-pnull[2]
theta12<-(thetarr*(theta11+theta21)*(1-theta11)-theta11*(1-theta11-theta21))/(thetarr*(theta11+theta21)+(1-theta11-theta21))
theta22<-1-theta11-theta12-theta21
#if(theta11>delta && theta11<(1-delta) && theta21>delta && theta21<(1-delta) && (theta11+theta21)<(1-delta) && (thetarr*theta11+(thetarr+1)*theta21)<(1-delta) && theta12>delta && theta12<(1-delta) && theta22>delta && theta22<(1-delta))
if(theta11>delta && theta11<(1-delta) && theta21>delta && theta21<(1-delta) && theta12>delta && theta12<(1-delta) && theta22>delta && theta22<(1-delta))
{
part2<-I1*(log(theta11)) +(I2)*(log(theta12)) + (I3)*(log(theta21)) + (I4)*(log(theta22))
sum<-part1+part2
expsum<-exp(sum)
mansum<-sum(expsum)
}else{mansum<-(-10)}
return(-mansum)
}

maxloc<-which(sumofprob==mansum)

resu<-nlminb(c(theta11[maxloc],theta21[maxloc]),llike,lower=c(delta,delta),upper=c(upper11,upper21))

mansum<-max(-resu$objective,mansum)

return(mansum)
}

probgridmin<-function(midv)
{
delta<-10^{-26}
theta11_g<-seq(delta,min(1-delta,1/midv-delta),length=grid.one)
theta21_g<-seq(delta,min(1-delta,1/(midv+1)-delta),length=grid.one)
theta11<-rep(theta11_g,times=grid.one)
theta21<-rep(theta21_g,each=grid.one)
thetarr<-midv
theta12<-(thetarr*(theta11+theta21)*(1-theta11)-theta11*(1-theta11-theta21))/(thetarr*(theta11+theta21)+(1-theta11-theta21))
theta22<-1-theta11-theta12-theta21
thetaallone<-cbind(theta11,theta21,theta12,theta22)
thetaall<-thetaallone[which(thetaallone[,3]>delta),]
thetaall<-thetaall[which(thetaall[,3]<(1+delta)),]
thetaall<-thetaall[which(thetaall[,4]>delta),]
thetaall<-thetaall[which(thetaall[,4]<(1+delta)),]
theta11<-thetaall[,1]
theta21<-thetaall[,2]
theta12<-thetaall[,3]
theta22<-thetaall[,4]

part2<-I1%*%t(log(theta11)) +(I2)%*%t(log(theta12)) + (I3)%*%t(log(theta21)) + (I4)%*%t(log(theta22))
sum<-part1+part2
expsum<-exp(sum)
sumofprob<-colSums(expsum)
mansum<-min(sumofprob)

maxloc<-which(sumofprob==mansum)
stepv<-(max(theta11_g)-min(theta11_g))/grid.one
theta11_g<-seq(max(delta,(theta11[maxloc]-stepv+delta)),min(1-delta,1/midv-delta,(theta11[maxloc]+stepv-delta)),length=grid.two)
theta21_g<-seq(max(delta,(theta21[maxloc]-stepv+delta)),min(1-delta,1/(midv+1)-delta,(theta21[maxloc]+stepv-delta)),length=grid.two)
thetarr<-midv
theta12<-(thetarr*(theta11+theta21)*(1-theta11)-theta11*(1-theta11-theta21))/(thetarr*(theta11+theta21)+(1-theta11-theta21))
theta22<-1-theta11-theta12-theta21
thetaallone<-cbind(theta11,theta21,theta12,theta22)
thetaall<-thetaallone[which(thetaallone[,3]>delta),]
thetaall<-thetaall[which(thetaall[,3]<(1+delta)),]
thetaall<-thetaall[which(thetaall[,4]>delta),]
thetaall<-thetaall[which(thetaall[,4]<(1+delta)),]
theta11<-thetaall[,1]
theta21<-thetaall[,2]
theta12<-thetaall[,3]
theta22<-thetaall[,4]

part2<-I1%*%t(log(theta11)) +(I2)%*%t(log(theta12)) + (I3)%*%t(log(theta21)) + (I4)%*%t(log(theta22))
sum<-part1+part2
expsum<-exp(sum)
sumofprob<-colSums(expsum)
mansum<-min(sumofprob)

return(mansum)
}




dimoftable<-dim(Ls)[1]
numnum<-0

#if(n12==n && t==0 && alternative=="Lower"){output[2]=Ls[1,4];output[3]=1;kk<-dimoftable}
#if(n12==0 && t==0 && alternative=="Lower"){output[2]=-1;output[3]=1;kk<-dimoftable}
#if(n12==n && t==0 && alternative=="Upper"){output[2]=-1;output[3]=1;kk<-dimoftable}  
#if(n12==0 && t==0 && alternative=="Upper"){output[2]=-1;output[3]=-Ls[1,4];kk<-dimoftable}  



#while(kk<=(dimoftable-1))
while(kk<=92)
{

C<-Ls[(kk-morepoint+1):kk,1:3]
S[(kk-morepoint+1):kk,]<-C
DD<-S[1:kk,]
if(kk==1){DD[2]<-DD[2]-1}else{
DD[,2]<-DD[,2]-1}
Bv<-DD
DD<-S[1:kk,]
if(kk==1){DD[3]<-DD[3]+1}else{
DD[,3]<-DD[,3]+1}
Cv<-DD
DD<-S[1:kk,]
if(kk==1){DD[1]<-DD[1]-1}else{
DD[,1]<-DD[,1]-1}
Dv<-DD

SKvector<-(S[1:kk,1]+1)*(n+3)^2+(S[1:kk,2]+1)*(n+3)+(S[1:kk,3]+1)
if(morepoint==1){NNvector<-(C[1]+2)*(n+3)^2+(C[2]+1)*(n+3)+(C[3]+1)}else{
NNvector<-(C[,1]+2)*(n+3)^2+(C[,2]+1)*(n+3)+(C[,3]+1)}
eindex<-1-is.element(NNvector,SKvector)*1

DD<-S[1:kk,]
if(kk==1){DD[1]<-DD[1]+1;DD[2]<-DD[2]-eindex}else{
DD[,1]<-DD[,1]+1;DD[,2]<-DD[,2]-eindex}
AEv<-DD

N<-rbind(Bv,Cv,Dv,AEv)
N<-unique(N)


Nvector<-c()
Nvector<-(N[,1]+1)*(n+3)^2+(N[,2]+1)*(n+3)+(N[,3]+1)
Nvector<-Nvector[is.element(Nvector,allvectormove)]




#SKvector<-(S[1:kk,1]+1)*(n+3)^2+(S[1:kk,2]+1)*(n+3)+(S[1:kk,3]+1)
Nvectortemp<-Nvector[!is.element(Nvector,SKvector)]
Ntemp<-array(,dim=c(length(Nvectortemp),3))
Ntemp[,3]<-Nvectortemp%%(n+3)
Ntemp[,2]<-((Nvectortemp-Ntemp[,3])/(n+3))%%(n+3)
Ntemp[,1]<-(Nvectortemp-Ntemp[,3]-Ntemp[,2]*(n+3))/(n+3)^2-1
Ntemp[,2]<-Ntemp[,2]-1
Ntemp[,3]<-Ntemp[,3]-1
N<-Ntemp

## add (n,0,0) to N_{n-1,1,0}
#CDE<-C
#if(morepoint==1){CCNvector<-(CDE[1]+1)*(n+3)^2+(CDE[2]+1)*(n+3)+(CDE[3]+1)}else{
#CCNvector<-(CDE[,1]+1)*(n+3)^2+(CDE[,2]+1)*(n+3)+(CDE[,3]+1)}
#CCNnvalue<-(n-1+1)*(n+3)^2+(1+1)*(n+3)+(0+1)
#if(stopp<0.5)
#{
#if(is.element(CCNnvalue,CCNvector))
#{
#N=rbind(N,c(n,0,0))
#stopp=1
#}
#}


####################  NC ####


Nvector<-(N[,1]+1)*(n+3)^2+(N[,2]+1)*(n+3)+(N[,3]+1)
Nvector1<-(N[,1]+1)*(n+3)^2+(N[,2]+2)*(n+3)+(N[,3]+1)
Nvector2<-(N[,1]+1)*(n+3)^2+(N[,2]+1)*(n+3)+(N[,3])

drop<-is.element(Nvector1,Nvector)*1+is.element(Nvector2,Nvector)*1
M<-cbind(N,drop)
MM<-M[which(M[,4]<0.5),]
#NCtemp<-MM
#NCtemp<-cbind(NCtemp,1)
#NCtt1<-NCtemp[,1]
#NCtt2<-NCtemp[,2]
#NCtt3<-NCtemp[,3]
#NCtt4<-n-NCtt1-NCtt2-NCtt3
#NCtemp[,5]<-log(NCtt1*NCtt4/(NCtt2+delta)/(NCtt3+delta)+delta)-1.645*sqrt(1/(NCtt1+delta)+1/(NCtt2+delta)+1/(NCtt3+delta)+1/(NCtt4+delta))
## Desu and raghavarao 2004 book. 
#NCtemp[,5]<-(NCtt1+NCtt2)/(NCtt1+NCtt3+delta)*exp(-1.645*sqrt(NCtt2+NCtt3)/(NCtt1+NCtt2+delta)/(NCtt1+NCtt3+delta))

#NCtemp<-NCtemp[order(-NCtemp[,2],-NCtemp[,3],-NCtemp[,1]),]
#NCtemp<-NCtemp[order(-NCtemp[,5]),]

#NC<-NCtemp[,1:4]

NC<-MM

if(length(NC)<=5){lengthNC=1;NMN=array(c(100,100,100,100,100,100,100,100,100),dim=c(2,4));NMN[1,]<-NC;NC<-NMN;NCgroup<-array(,dim=c(4,5))}else{lengthNC=length(na.omit(NC[,1]));NCgroup<-array(,dim=c(4*lengthNC,5))}


if(lengthNC>1.5){
NCsimple<-array(,dim=c(4*lengthNC,4))
NCindex<-0
j=1
NCabc<-array(,dim=c(2,4))
NCabc[1,1:3]<-NC[j,1:3]
NCabc[2,1:3]<-c(n-NC[j,1]-NC[j,2]-NC[j,3],NC[j,2],NC[j,3])
NCabcd<-unique(NCabc)
NCabcd[,4]<-(NCabcd[,1])*(n+2)^2+(NCabcd[,2])*(n+2)+(NCabcd[,3])
NCsimple[(NCindex+1):(NCindex+dim(NCabcd)[1]),]<-NCabcd
NCindex<-NCindex+dim(NCabcd)[1]
for(j in 2:lengthNC){
tempvv<-(NC[j,1])*(n+2)^2+(NC[j,2])*(n+2)+(NC[j,3])
if(tempvv %in% NCsimple[1:NCindex,4]){
print(j)
NC[j,4]<-1
}else{
NCabc<-array(,dim=c(4,4))
NCabc[1,1:3]<-NC[j,1:3]
NCabc[2,1:3]<-c(n-NC[j,1]-NC[j,2]-NC[j,3],NC[j,2],NC[j,3])
NCabcd<-unique(NCabc)
NCabcd[,4]<-(NCabcd[,1])*(n+2)^2+(NCabcd[,2])*(n+2)+(NCabcd[,3])
NCsimple[(NCindex+1):(NCindex+dim(NCabcd)[1]),]<-NCabcd
NCindex<-NCindex+dim(NCabcd)[1]
       }
                     }
               }
NC<-NC[which(NC[,4]<0.5),]

if(length(NC)<=5){lengthNC=1;NMN=array(c(100,100,100,100,100,100,100,100,100),dim=c(2,4));NMN[1,]<-NC;NC<-NMN}else{lengthNC=length(na.omit(NC[,1]))}


kkstart=kk+1

for(i in 1:lengthNC)
{
imax=100-100*delta
imin=0+delta

Ls[kk+1,1:3]<-NC[i,1:3]
I1<-Ls[1:(kk+1),1]
I2<-Ls[1:(kk+1),2]
I3<-Ls[1:(kk+1),3]

kkid<-kk+1

if(NC[i,1]!=(n-NC[i,1]-NC[i,2]-NC[i,3]))
{
kkid<-kkid+1
Ls[kkid,1:3]<-c((n-NC[i,1]-NC[i,2]-NC[i,3]),NC[i,2],NC[i,3])
I1<-Ls[1:kkid,1]
I2<-Ls[1:kkid,2]
I3<-Ls[1:kkid,3]
}


I4<-n-I1-I2-I3

kkend<-kkstart+kkid-kk-1

NCgroup[(kkstart-kk):(kkend-kk),1:4]<-cbind(I1[(kk+1):kkid],I2[(kk+1):kkid],I3[(kk+1):kkid],0)



part1<-lfactorial(n)-lfactorial(I1)-lfactorial(I2)-lfactorial(I3)-lfactorial(I4)


#if(kk>(dimoftable-2)/2)
if(kk>(dimoftable-2))
{
partvector<-round(NC[i,1]*(n+2)^2+NC[i,2]*(n+2)+NC[i,3])
leftvector<-setdiff(allvector,partvector)
I3<-round(leftvector%%(n+2))
I2<-round(((leftvector-I3)/(n+2))%%(n+2))
I1<-round((leftvector-I3-I2*(n+2))/(n+2)^2)
I4<-n-I1-I2-I3
part1<-lfactorial(n)-lfactorial(I1)-lfactorial(I2)-lfactorial(I3)-lfactorial(I4)
}



imax=Ls[kk,4]
imin=0+delta
if(i==1){NCmax<-imin}

#if(kk<=(dimoftable-2)/2){
if(kk<=(dimoftable-2)){
if(i==1){
while(abs(imax-imin)>=precision)
{
mid<-(imax+imin)/2
probmid<-probgridmax(mid)
if(probmid>=alpha)
{imax<-mid}else{imin<-mid}
}
NC[i,4]<-round(imin,digits=pround)                               
         } ## i==1
if(i>1){
sectable=probgridmax(NCmax)
if(sectable<(alpha-0.0001)){
imin<-NCmax*0.9
print(c(i,lengthNC))
calnum=calnum+1
while(abs(imax-imin)>=precision)
{
mid<-(imax+imin)/2
probmid<-probgridmax(mid)
if(probmid>=alpha)
{imax<-mid}else{imin<-mid}
}
NC[i,4]<-round(imin,digits=pround)                      
         }else{ 
imin=NCmax-0.2
NC[i,4]<-round(imin,digits=pround)
               }
         }## i>1
NCmax<-max(NCmax,imin)
         }else{          				
	if(i==1){
while(abs(imax-imin)>=precision)
{
mid<-(imax+imin)/2
probmid<-probgridmin(mid)
if(probmid>=(1-alpha))
{imin<-mid}else{imax<-mid}
}
NC[i,4]<-round(imin,digits=pround)                              
         } ## i==1
if(i>1){
sectable=probgridmin(NCmax)
if(sectable>=(1-alpha+0.00001)){
imin<-NCmax*0.9
print(c(i,lengthNC))
calnum=calnum+1
while(abs(imax-imin)>=precision)
{
mid<-(imax+imin)/2
probmid<-probgridmin(mid)
if(probmid>=(1-alpha))
{imin<-mid}else{imax<-mid}
}
NC[i,4]<-round(imin,digits=pround)                      
         }else{ 
imin=NCmax-0.2
NC[i,4]<-round(imin,digits=pround)
               }
         }## i>1
NCmax<-max(NCmax,imin)			
				
				} 
NCgroup[(kkstart-kk):(kkend-kk),4]<-NC[i,4]
NCgroup[(kkstart-kk):(kkend-kk),5]<-i
kkstart<-kkend+1
#print(c(i,NCmax))
}##  end of i loop


ikk<-length((na.omit(NCgroup)))

morepointLsest<-function(morekk)
{

I1<-Ls[1:morekk,1]
I2<-Ls[1:morekk,2]
I3<-Ls[1:morekk,3]
I4<-n-I1-I2-I3

part1<-lfactorial(n)-lfactorial(I1)-lfactorial(I2)-lfactorial(I3)-lfactorial(I4)


probgrid<-function(midv)
{
delta<-10^{-26}
theta11_g<-seq(delta,min(1-delta,1/midv-delta),length=grid.one)
theta21_g<-seq(delta,min(1-delta,1/(midv+1)-delta),length=grid.one)
theta11<-rep(theta11_g,times=grid.one)
theta21<-rep(theta21_g,each=grid.one)
thetarr<-midv
theta12<-(thetarr*(theta11+theta21)*(1-theta11)-theta11*(1-theta11-theta21))/(thetarr*(theta11+theta21)+(1-theta11-theta21))
theta22<-1-theta11-theta12-theta21
thetaallone<-cbind(theta11,theta21,theta12,theta22)
thetaall<-thetaallone[which(thetaallone[,3]>delta),]
thetaall<-thetaall[which(thetaall[,3]<(1+delta)),]
thetaall<-thetaall[which(thetaall[,4]>delta),]
thetaall<-thetaall[which(thetaall[,4]<(1+delta)),]
theta11<-thetaall[,1]
theta21<-thetaall[,2]
theta12<-thetaall[,3]
theta22<-thetaall[,4]

part2<-I1%*%t(log(theta11)) +(I2)%*%t(log(theta12)) + (I3)%*%t(log(theta21)) + (I4)%*%t(log(theta22))
sum<-part1+part2
expsum<-exp(sum)
sumofprob<-colSums(expsum)
mansum<-max(sumofprob)
return(mansum)
}



#imax=Ls[kk,4]
imax=10
imin=0+delta

if(ikk<7){NCmax<-imin}

while(abs(imax-imin)>=precision)
{
mid<-(imax+imin)/2
probmid<-probgrid(mid)
if(probmid>=alpha)
{imax<-mid}else{imin<-mid}
}
NCres<-round(imin,digits=pround)
return(NCres)
	}## end of function morepointLsest

partvector<-c()
if(ikk>=8)
{NCnomiss<-NCgroup[1:dim(na.omit(NCgroup))[1],]
NCnomiss<-NCnomiss[order(-NCnomiss[,4]),]
morepoint<-sum(NCnomiss[,4]>=NCnomiss[1,4]-0.0001)
morepointv<-length(unique(NCnomiss[1:morepoint,5]))

if(morepointv>=2){
Ls[(kk+1):(kk+morepoint),1:3]<-NCnomiss[1:morepoint,1:3]
#Ls[(kk+1):(kk+morepoint),4]<-1  ## more points in the rejection region
Ls[(kk+1):(kk+morepoint),4]<-morepointLsest(kk+morepoint)  ## more points in the rejection region

for(iq in 1:morepoint)
{partvector[iq]<-round(Ls[kk+iq,1]*(n+2)^2+Ls[kk+iq,2]*(n+2)++Ls[kk+iq,3])
allvector<-setdiff(allvector,partvector[iq])}
kk=kk+morepoint
             }else{pointv<-morepoint
			Ls[(kk+1):(kk+pointv),1:4]<-NCnomiss[1:pointv,1:4]
			for(iq in 1:morepoint)
			{partvector[iq]<-round(Ls[kk+iq,1]*(n+2)^2+Ls[kk+iq,2]*(n+2)++Ls[kk+iq,3])
			allvector<-setdiff(allvector,partvector[iq])}
			kk=kk+pointv
                   }
}else{pointv<-dim(na.omit(NCgroup))[1]
Ls[(kk+1):(kk+pointv),1:4]<-NCnomiss[1:pointv,1:4]
for(iq in 1:morepoint)
{partvector[iq]<-round(Ls[kk+iq,1]*(n+2)^2+Ls[kk+iq,2]*(n+2)++Ls[kk+iq,3])
allvector<-setdiff(allvector,partvector[iq])}
kk=kk+pointv
}


kk1=kk
print(c(kk,(dimoftable-2)/2))
numnum=numnum+1
Ls[kk,8]<-numnum
print(Ls[1:kk,])

if(datavector %in% partvector){numindex1=1}
if(datavector12 %in% partvector){numindex2=1}
if(numindex1==1 && numindex2==1){kk=dimoftable+20}
print(c(numindex1,numindex2))

}


#Ls[kk+1,c(1,2,3,4)]=c(5,0,0,0) ## double check 5 0 0 0 as the last table

p1hat<-(Ls[,1]+Ls[,2])
p0hat<-(Ls[,1]+Ls[,3])+delta
Ls[,6]=(p1hat/p0hat)

head(Ls)
Ls[1:kk,]

Lsold=Ls[,4]

timeb<-Sys.time()
timeb-timea
calnum


#write.table(Lsss,"C:\\swshare\\PairedOR_Lower_95-052202.txt")

# Ls11<-Ls
# Ls11[order(Ls11[,1],Ls11[,2],Ls11[,3]),]



